package com.eactive.eai.rms.bap.manage.schedule.businessDay;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

import com.eactive.eai.rms.common.base.BapBaseAnnotationController;
import com.eactive.eai.rms.common.combo.ComboService;
import com.eactive.eai.rms.common.util.CamelCaseUtil;
import com.eactive.eai.rms.common.vo.JsonPageVo;
import com.eactive.eai.rms.onl.common.util.DateUtil;

@Controller
public class BapBusinessDayController extends BapBaseAnnotationController  {

	@Autowired
	@Qualifier("bapBusinessDayService")
	private BapBusinessDayService service;

	@RequestMapping(value= "/bap/admin/schedule/businessDayMan.view")
	public String viewList(HttpServletRequest request, @RequestParam(value = "cmd", required = false ) String cmd ) throws Exception {
		if (cmd == null || "LIST".equals(cmd.toUpperCase())){
			cmd = "";
		}else {
			cmd = CamelCaseUtil.converCamelCase(cmd);
		}
		String path = request.getServletPath();
		return path.split("[.]")[0]+cmd;
	}
	
	/**
	 * @param request
	 * @param response
	 * @throws Exception
	 */
	@RequestMapping(value= "/bap/admin/schedule/businessDayMan.json", params = "cmd=LIST")
	public ModelAndView selectList(HttpServletRequest request,
			JsonPageVo pageVo , @RequestParam HashMap<String, Object> paramMap) throws Exception {
		
		String likeBaseDT = (String)paramMap.get("likeBaseDT");
				
		if("%%".equals(likeBaseDT)) {	// 기준일자 검색어가 없을 때는 당월 데이터 list 
			paramMap.put("likeBaseDT", "%"+DateUtil.getDate().substring(0, 6)+"%");
		}

		HashMap<String, Object> map = service.selectList( pageVo.getStartNum(), pageVo.getEndNum(), paramMap);
		
		pageVo.setTotalCount((Integer)map.get("totalCount"));
		
		Map<String, Object> resultMap = new HashMap<String, Object>();
		resultMap.put("total"  , pageVo.getTotal());  //전체 페이지수
		resultMap.put("page"   , pageVo.getPage());   //현재 페이지수
		resultMap.put("records", pageVo.getTotalCount());//전체 레코드건수	
		resultMap.put("rows"   , map.get("list"));
		
		ModelAndView modelAndView = new ModelAndView("jsonView",resultMap);		
		return modelAndView;
		
	}

	@RequestMapping(value= "/bap/admin/schedule/businessDayMan.json",params = "cmd=DETAIL")
	public ModelAndView selectDetail(HttpServletRequest request,
			HttpServletResponse response, String bJobMsgScheId) throws Exception {
		
		HashMap<String, Object> map = service.selectDetail(bJobMsgScheId);

		ModelAndView modelAndView = new ModelAndView("jsonView", map);	
		return modelAndView;
	}
	
	@RequestMapping(value= "/bap/admin/schedule/businessDayMan.json",params = "cmd=INSERT")
	public String insert(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String, Object> map) throws Exception {

		service.insert(map);

		return null;
	}	
	
	@RequestMapping(value= "/bap/admin/schedule/businessDayMan.json",params = "cmd=UPDATE")
	public String update(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String, Object> map ) throws Exception {

		service.update(map);

		return null;
	}
	
	@RequestMapping(value= "/bap/admin/schedule/businessDayMan.json",params = "cmd=DELETE")
	public String delete(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String, Object> map ) throws Exception {
		
		service.delete(map);
		
		return null;
	}

}